function f_approx = Proj_linear(z,Z_select,f_T1,f_T2)
%get the solution at time T2 from basis f_T1 and f_T2
[Nx,Nv,n] = size(f_T1); N = Nx*Nv;
[Nz,~] = size(z);
if n == 1
    f_approx = repmat(f_T2,1,1,Nz);
end

if n > 1
Y = Residual_linear(f_T1,f_T2,Z_select,z);

%     %check whether change the sequence of Y matters
%     for k = 1:n
%         Y = circshift(Y,[0,1]);
%         [~,~,a(:,:,k)] = Max_residual_linear(Y);
%         a(:,:,k) = circshift(a(:,:,k),[-k,0]);
%         f_approx(:,:,:,k) = reshape(reshape(f_T2,N,n)*a(:,:,k),Nx,Nv,Nz);
%     end

    %When no discontinuous 
[~,~,a] = Max_residual_linear(Y);
f_approx = reshape(reshape(f_T2,N,n)*a,Nx,Nv,Nz);

end








