function f = Trig_Multi(A,g)
%This is multiplication of hat_A*g, where hat_A is a tri-diag matrix, 
%with diag(hat_A) = A, and off diagnal = 1
[Nx,Nv,Nz_1,Nz_2] = size(A);
g_plus = circshift(g,[0,-1,0,0]);
g_plus(:,Nv,:,:) = zeros(Nx,1,Nz_1,Nz_2);
g_minu = circshift(g,[0,1,0,0]);
g_minu(:,1,:,:) = zeros(Nx,1,Nz_1,Nz_2);
f = g_plus + A.*g + g_minu;